// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockEnvironments is an autogenerated mock type for the Environments type
type MockEnvironments struct {
	mock.Mock
}

// CreateEnvironment provides a mock function with given fields: ctx, environment
func (_m *MockEnvironments) CreateEnvironment(ctx context.Context, environment *models.Environment) (*models.Environment, error) {
	ret := _m.Called(ctx, environment)

	if len(ret) == 0 {
		panic("no return value specified for CreateEnvironment")
	}

	var r0 *models.Environment
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Environment) (*models.Environment, error)); ok {
		return rf(ctx, environment)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.Environment) *models.Environment); ok {
		r0 = rf(ctx, environment)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Environment)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.Environment) error); ok {
		r1 = rf(ctx, environment)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteEnvironment provides a mock function with given fields: ctx, environment
func (_m *MockEnvironments) DeleteEnvironment(ctx context.Context, environment *models.Environment) error {
	ret := _m.Called(ctx, environment)

	if len(ret) == 0 {
		panic("no return value specified for DeleteEnvironment")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Environment) error); ok {
		r0 = rf(ctx, environment)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetEnvironmentByID provides a mock function with given fields: ctx, id
func (_m *MockEnvironments) GetEnvironmentByID(ctx context.Context, id string) (*models.Environment, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetEnvironmentByID")
	}

	var r0 *models.Environment
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Environment, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Environment); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Environment)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetEnvironmentByPRN provides a mock function with given fields: ctx, prn
func (_m *MockEnvironments) GetEnvironmentByPRN(ctx context.Context, prn string) (*models.Environment, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetEnvironmentByPRN")
	}

	var r0 *models.Environment
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Environment, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Environment); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Environment)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetEnvironments provides a mock function with given fields: ctx, input
func (_m *MockEnvironments) GetEnvironments(ctx context.Context, input *GetEnvironmentsInput) (*EnvironmentsResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetEnvironments")
	}

	var r0 *EnvironmentsResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetEnvironmentsInput) (*EnvironmentsResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetEnvironmentsInput) *EnvironmentsResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*EnvironmentsResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetEnvironmentsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateEnvironment provides a mock function with given fields: ctx, environment
func (_m *MockEnvironments) UpdateEnvironment(ctx context.Context, environment *models.Environment) (*models.Environment, error) {
	ret := _m.Called(ctx, environment)

	if len(ret) == 0 {
		panic("no return value specified for UpdateEnvironment")
	}

	var r0 *models.Environment
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Environment) (*models.Environment, error)); ok {
		return rf(ctx, environment)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.Environment) *models.Environment); ok {
		r0 = rf(ctx, environment)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Environment)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.Environment) error); ok {
		r1 = rf(ctx, environment)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockEnvironments creates a new instance of MockEnvironments. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockEnvironments(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockEnvironments {
	mock := &MockEnvironments{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
